/***************************************************************************
 *   Copyright (C) 2005 by James Thorniley                                 *
 *   james@uncommonlygood.co.uk                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCANBUSTHREAD_H
#define SCANBUSTHREAD_H

#include <qthread.h>
#include <qvaluelist.h>
#include "config.h"

#ifdef HAVE_K3B
namespace K3bCdDevice{
  class DeviceManager;
}

using namespace K3bCdDevice;
#endif

typedef struct Device {
  bool isCDR, isDVDR;
  bool CDR, CDRW, DVDMR, DVDRAM, DVDMRWrovr, DVDMRWrrec, DVDPRW, DVDPR;
  QString desc, fileName;
};
    
/**
Scans available scsi drives to see if they are CD/DVD burners and check on their features

@author James Thorniley
*/
class ScanBusThread : public QThread
{
public:
  ScanBusThread(); //will scan the entire bus
    ScanBusThread( const QString & fileName ); //will scan device at fileName for current media

    ~ScanBusThread();

    QValueList<Device> & deviceList() { return m_deviceList; }
    
    enum { CDR, CDRW, DVDMR, DVDMRWrovr, DVDMRWrrec, DVDRAM, DVDPR, DVDPRW, UNKNOWN } currentMedia ;
    
  protected:
    virtual void run();
    QValueList<Device> m_deviceList;
    QString *m_fileName;
    bool m_scanFileOnly;

#ifdef HAVE_K3B
    DeviceManager *m_deviceManager;
#endif
};

#endif
